Subject: Re: bug#24500: 25.1.50; Can't other-window from minibuffer if Ediff control panel frame present

From: Richard Copley <[email-masked]>
Date: Fri, 30 Sep 2016 19:21:09 +0100

On 30 September 2016 at 19:13, Richard Copley <[email-masked]> wrote:
> On 30 September 2016 at 09:32, martin rudalics <[email-masked]> wrote:
>>> With patch (1) the focus can get stuck. Having saved the "my-other-window"
>>> example above as "x.el", from "emacs -Q",
>>>
>>> M-x load-file RET x.el RET ;; Creates and selects a minibuffer-less frame.
>>> ;; Call the initial frame "frame 1" and the minibuffer-less frame "frame
>>> 2".
>>> C-x b window2 RET ;; Select named window in frame 2 for clarity.
>>> C-x 5 o ;; Switch to frame 1
>>> M-x
>>> C-x 5 o ;; Switch to frame 2
>>> C-x o ;; Select window *scratch* in frame 1.
>>> C-x o ;; Select minibuffer.
>>> C-g ;; Quit M-x
>>> ;; Selected frame is frame 2
>>
>> Why do you think so?  The selected frame is frame 1 ever since C-x o
>> selected it (and it did so twice in a row).
>
> OK, then I now realize I have no idea what "selected frame" means.
> The fact I was attempting to express is that the activated window
> at the window-manager level is frame 2.
>
>>> and selected window in frame 2 is "window2",
>>> ;; but focus is still redirected to frame 1 (selected window now
>>> "*scratch*").
>>> xyzzy ;; Characters are inserted in *scratch*.
>>>
>>> No amount of switching between frames 1 and 2 changes the focus
>>> redirection,
>>
>> I'm not sure I understand what you mean here.  Do you mean that C-x 5 o
>> after the C-g does not select window2?
>
> I'd better assume that I don't know what "select window2" means either.
>
> I mean that the window with the solid flashing cursor where text is inserted
> when you type characters is window2,

Not window2, sorry. Rather, it's the window displaying *scratch* on frame 1.

> and that can't be changed by
> typing Alt-Tab (which on this Windows system is not passed to Emacs but
> activates a different window), nor by clicking on the non-client area of frame
> 1.
>
> In fact I hadn't tried C-x 5 o. That does fix things.
>
>>> but clicking inside a window on frame 2 does remove
>>> the redirection and get things back to normal.
>
>> What was abnormal before?
>
> I have no idea what's normal and what isn't any more :)
>
> I had expected activating frame 2 (using the window manager) to let me
> type characters into window2.
>
>>> I'll try patch (2) later. It sounds logical to me.
>>
>> martin